Skip site navigation (1)Skip section navigation (2)
Date:      Fri, 11 Jan 2013 09:25:50 +0000 (UTC)
From:      Peter Holm <pho@FreeBSD.org>
To:        src-committers@freebsd.org, svn-src-user@freebsd.org
Subject:   svn commit: r245294 - user/pho/stress2/misc
Message-ID:  <201301110925.r0B9PoQ4045144@svn.freebsd.org>

next in thread | raw e-mail | index | archive | help
Author: pho
Date: Fri Jan 11 09:25:50 2013
New Revision: 245294
URL: http://svnweb.freebsd.org/changeset/base/245294

Log:
  Unmapped I/O test scenario.

Added:
  user/pho/stress2/misc/rot.sh   (contents, props changed)

Added: user/pho/stress2/misc/rot.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ user/pho/stress2/misc/rot.sh	Fri Jan 11 09:25:50 2013	(r245294)
@@ -0,0 +1,138 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2012 Peter Holm <pho@FreeBSD.org>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+
+# Unmapped I/O test scenario:
+# http://people.freebsd.org/~pho/stress/log/kostik515.txt
+
+. ../default.cfg
+
+here=`pwd`
+cd /tmp
+sed '1,/^EOF/d' < $here/$0 > rot.c
+cc -o rot -Wall -Wextra -O2 -g rot.c || exit 1
+rm -f rot.c
+cd $here
+
+mount | grep $mntpoint | grep -q /dev/md && umount -f $mntpoint
+mdconfig -l | grep -q md$mdstart &&  mdconfig -d -u $mdstart
+
+mdconfig -a -t swap -s 2g -u $mdstart || exit 1
+bsdlabel -w md$mdstart auto
+
+newfs -U md${mdstart}$part > /dev/null
+
+mount /dev/md${mdstart}$part $mntpoint
+chmod 777 $mntpoint
+
+(cd $mntpoint; /tmp/rot)
+(cd /tmp;      /tmp/rot)
+
+while mount | grep $mntpoint | grep -q /dev/md; do
+	umount $mntpoint || sleep 1
+done
+mdconfig -d -u $mdstart
+rm -f /tmp/rot
+exit
+EOF
+#include <err.h>
+#include <fcntl.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <sys/mman.h>
+#include <sys/wait.h>
+#include <unistd.h>
+
+#define N 10240	/* 40 Mb */
+#define PARALLEL 20
+
+int
+test(void)
+{
+	unsigned char *buf;
+	char path[128];
+	int fd, i, j, s;
+
+	s = getpagesize();
+
+	sprintf(path,"%s.%05d", getprogname(), getpid());
+	if ((fd = open(path, O_RDWR | O_CREAT | O_TRUNC, 0600)) < 0)
+		err(1, "open(%s)", path);
+	if (lseek(fd, s * N - 1, SEEK_SET) == -1)
+                        err(1, "lseek error");
+
+	/* write a dummy byte at the last location */
+	if (write(fd, "", 1) != 1)
+		err(1, "write error");
+
+	for (i = 0; i < N; i++) {
+		if ((buf = mmap(0, s, PROT_READ | PROT_WRITE, MAP_SHARED, fd, i * s)) == MAP_FAILED)
+			err(1, "write map");
+		for (j = 0; j < s; j++)
+			buf[j] = i % 256;
+	}
+	if (munmap(buf, s) == -1)
+		err(1, "unmap (write)");
+	close(fd);
+
+	if ((fd = open(path, O_RDONLY)) < 0)
+		err(1, "open(%s)", path);
+	for (i = 0; i < N; i++) {
+		if ((buf = mmap(0, s, PROT_READ, MAP_SHARED, fd, i * s)) == MAP_FAILED)
+			err(1, "write map");
+		for (j = 0; j < s; j++)
+			if (buf[j] != i % 256)
+				fprintf(stderr, "read %d, expected %d at %d\n",
+						buf[j], i % 256, i);
+	}
+	if (munmap(buf, s) == -1)
+		err(1, "unmap (read)");
+	close(fd);
+	unlink(path);
+
+	_exit(0);
+}
+
+int
+main(void)
+{
+	int i, j;
+
+	for (j = 0; j < 50; j++) {
+		for (i = 0; i < PARALLEL; i++)
+			if (fork() == 0)
+				test();
+		for (i = 0; i < PARALLEL; i++)
+			wait(NULL);
+	}
+
+	return(0);
+}



Want to link to this message? Use this URL: <https://mail-archive.FreeBSD.org/cgi/mid.cgi?201301110925.r0B9PoQ4045144>